/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.MaterrialLibrary;
import vip.xiaonuo.disk.mapper.MaterrialLibraryMapper;
import vip.xiaonuo.disk.param.MaterrialLibraryAddParam;
import vip.xiaonuo.disk.param.MaterrialLibraryEditParam;
import vip.xiaonuo.disk.param.MaterrialLibraryIdParam;
import vip.xiaonuo.disk.param.MaterrialLibraryPageParam;
import vip.xiaonuo.disk.service.MaterrialLibraryService;
import vip.xiaonuo.disk.vo.materrial.MaterrialLibraryVo;

import javax.annotation.Resource;
import java.util.List;

/**
 * 素材库Service接口实现类
 *
 * @author pans
 * @date  2025/07/01 16:16
 **/
@Service
public class MaterrialLibraryServiceImpl extends ServiceImpl<MaterrialLibraryMapper, MaterrialLibrary> implements MaterrialLibraryService {

    @Resource
    private  MaterrialLibraryMapper materrialLibraryMapper;

    @Override
    public Page<MaterrialLibraryVo> page(MaterrialLibraryPageParam materrialLibraryPageParam) {
        Page<MaterrialLibraryVo> page=materrialLibraryMapper.page(CommonPageRequest.defaultPage(),materrialLibraryPageParam);
        return page;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(MaterrialLibraryAddParam materrialLibraryAddParam) {
        MaterrialLibrary materrialLibrary = BeanUtil.toBean(materrialLibraryAddParam, MaterrialLibrary.class);
        materrialLibrary.setId(IdUtil.simpleUUID());
        this.save(materrialLibrary);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(MaterrialLibraryEditParam materrialLibraryEditParam) {
        MaterrialLibrary materrialLibrary = this.queryEntity(materrialLibraryEditParam.getId());
        BeanUtil.copyProperties(materrialLibraryEditParam, materrialLibrary);
        this.updateById(materrialLibrary);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<MaterrialLibraryIdParam> materrialLibraryIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(materrialLibraryIdParamList, MaterrialLibraryIdParam::getId));
    }

    @Override
    public MaterrialLibraryVo detail(MaterrialLibraryIdParam materrialLibraryIdParam) {
        MaterrialLibraryVo  detail= materrialLibraryMapper.detail(materrialLibraryIdParam.getId());
        return detail;
    }

    @Override
    public MaterrialLibrary queryEntity(String id) {
        MaterrialLibrary materrialLibrary = this.getById(id);
        if(ObjectUtil.isEmpty(materrialLibrary)) {
            throw new CommonException("素材库不存在，id值为：{}", id);
        }
        return materrialLibrary;
    }

}
